Index: sbin/instps/nlist.c
===================================================================
RCS file: sbin/instps/nlist.c
diff -N sbin/instps/nlist.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instps/nlist.c	12 Feb 2009 14:38:06 -0000	1.1.2.1
@@ -0,0 +1,103 @@
+/*	$OpenBSD: nlist.c,v 1.15 2005/01/07 20:41:13 otto Exp $	*/
+/*	$NetBSD: nlist.c,v 1.11 1995/03/21 09:08:03 cgd Exp $	*/
+
+/*-
+ * Copyright (c) 1990, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef lint
+#if 0
+static char sccsid[] = "@(#)nlist.c	8.4 (Berkeley) 4/2/94";
+#else
+static char rcsid[] = "$OpenBSD: nlist.c,v 1.15 2005/01/07 20:41:13 otto Exp $";
+#endif
+#endif /* not lint */
+
+#include <sys/param.h>
+#include <sys/time.h>
+#include <sys/proc.h>
+#include <sys/resource.h>
+#include <sys/sysctl.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stdio.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "ps.h"
+
+fixpt_t	ccpu;				/* kernel _ccpu variable */
+int	nlistread;			/* if nlist already read. */
+u_int	mempages;			/* number of pages of phys. memory */
+int	fscale;				/* kernel _fscale variable */
+int	maxslp;
+
+int
+donlist(void)
+{
+	int64_t physmem;
+	int rval, mib[2];
+	size_t siz;
+
+	rval = 0;
+	nlistread = 1;
+
+	siz = sizeof (fscale);
+	mib[0] = CTL_KERN;
+	mib[1] = KERN_FSCALE;
+	if (sysctl(mib, 2, &fscale, &siz, NULL, 0) < 0) {
+		warnx("fscale: failed to get kern.fscale");
+		eval = rval = 1;
+	}
+	siz = sizeof (physmem);
+	mib[0] = CTL_HW;
+	mib[1] = HW_PHYSMEM64;
+	if (sysctl(mib, 2, &physmem, &siz, NULL, 0) < 0) {
+		warnx("physmem: failed to get hw.physmem");
+		eval = rval = 1;
+	}
+	/* translate bytes into page count */
+	mempages = physmem / getpagesize();
+	siz = sizeof (ccpu);
+	mib[0] = CTL_KERN;
+	mib[1] = KERN_CCPU;
+	if (sysctl(mib, 2, &ccpu, &siz, NULL, 0) < 0) {
+		warnx("ccpu: failed to get kern.ccpu");
+		eval = rval = 1;
+	}
+	siz = sizeof (maxslp);
+	mib[0] = CTL_VM;
+	mib[1] = VM_MAXSLP;
+	if (sysctl(mib, 2, &maxslp, &siz, NULL, 0) < 0) {
+		warnx("maxslp: failed to get vm.maxslp");
+		eval = rval = 1;
+	}
+	return (rval);
+}
+
Index: sbin/instps/print.c
===================================================================
RCS file: sbin/instps/print.c
diff -N sbin/instps/print.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instps/print.c	12 Feb 2009 14:38:06 -0000	1.1.2.1
@@ -0,0 +1,659 @@
+/*	$OpenBSD: print.c,v 1.43 2007/11/06 10:22:29 chl Exp $	*/
+/*	$NetBSD: print.c,v 1.27 1995/09/29 21:58:12 cgd Exp $	*/
+
+/*-
+ * Copyright (c) 1990, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef lint
+#if 0
+static char sccsid[] = "@(#)print.c	8.6 (Berkeley) 4/16/94";
+#else
+static char rcsid[] = "$OpenBSD: print.c,v 1.43 2007/11/06 10:22:29 chl Exp $";
+#endif
+#endif /* not lint */
+
+#include <sys/param.h>
+#include <sys/time.h>
+#include <sys/resource.h>
+#include <sys/proc.h>
+#include <sys/stat.h>
+
+#include <sys/ucred.h>
+#include <sys/sysctl.h>
+#include <uvm/uvm_extern.h>
+
+#include <err.h>
+#include <grp.h>
+#include <math.h>
+#include <stddef.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <tzfile.h>
+#include <unistd.h>
+#include <pwd.h>
+
+#include "ps.h"
+
+extern int needcomm, neednlist;
+
+static char *cmdpart(char *);
+
+#define	min(a,b)	((a) < (b) ? (a) : (b))
+
+static char *
+cmdpart(char *arg0)
+{
+	char *cp;
+
+	return ((cp = strrchr(arg0, '/')) != NULL ? cp + 1 : arg0);
+}
+
+void
+printheader(void)
+{
+	VAR *v;
+	struct varent *vent;
+
+	for (vent = vhead; vent; vent = vent->next) {
+		v = vent->var;
+		if (v->flag & LJUST) {
+			if (vent->next == NULL)	/* last one */
+				(void)printf("%s", v->header);
+			else
+				(void)printf("%-*s", v->width, v->header);
+		} else
+			(void)printf("%*s", v->width, v->header);
+		if (vent->next != NULL)
+			(void)putchar(' ');
+	}
+	(void)putchar('\n');
+}
+
+void
+command(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+	int left, wantspace = 0;
+	char **argv, **p;
+
+	v = ve->var;
+	if (ve->next != NULL || termwidth != UNLIMITED) {
+		if (ve->next == NULL) {
+			left = termwidth - (totwidth - v->width);
+			if (left < 1) /* already wrapped, just use std width */
+				left = v->width;
+		} else
+			left = v->width;
+	} else
+		left = -1;
+
+	argv = NULL;
+	if (needcomm) {
+		if (wantspace) {
+			fmt_putc(' ', &left);
+			wantspace = 0;
+		}
+		fmt_puts(kp->p_comm, &left);
+	}
+	if (ve->next && left > 0) {
+		if (wantspace) {
+			fmt_putc(' ', &left);
+			wantspace = 0;
+		}
+		printf("%*s", left, "");
+	}
+}
+
+void
+ucomm(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%-*s", v->width, kp->p_comm);
+}
+
+void
+logname(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	if (kp->p_login[0]) {
+		int n = min(v->width, MAXLOGNAME);
+		(void)printf("%-*.*s", n, n, kp->p_login);
+		if (v->width > n)
+			(void)printf("%*s", v->width - n, "");
+	} else
+		(void)printf("%-*s", v->width, "-");
+}
+
+#define pgtok(a)	(((a)*getpagesize())/1024)
+
+void
+state(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	extern int ncpu;
+	int flag;
+	char *cp, state = '\0';
+	VAR *v;
+	char buf[16];
+
+	v = ve->var;
+	flag = kp->p_flag;
+	cp = buf;
+
+	switch (kp->p_stat) {
+
+	case SSTOP:
+		*cp = 'T';
+		break;
+
+	case SSLEEP:
+		if (flag & P_SINTR)	/* interruptible (long) */
+			*cp = kp->p_slptime >= maxslp ? 'I' : 'S';
+		else
+			*cp = 'D';
+		break;
+
+	case SRUN:
+	case SIDL:
+	case SONPROC:
+		state = *cp = 'R';
+		break;
+
+	case SZOMB:
+		*cp = 'Z';
+		break;
+
+	default:
+		*cp = '?';
+	}
+	cp++;
+
+	if (kp->p_nice < NZERO)
+		*cp++ = '<';
+	else if (kp->p_nice > NZERO)
+		*cp++ = 'N';
+	if (flag & P_TRACED)
+		*cp++ = 'X';
+	if (flag & P_SYSTRACE)
+		*cp++ = 'x';
+	if (flag & P_WEXIT && kp->p_stat != SZOMB)
+		*cp++ = 'E';
+	if (flag & P_PPWAIT)
+		*cp++ = 'V';
+	if (flag & P_SYSTEM)
+		*cp++ = 'K';
+	if ((flag & P_SYSTEM) == 0 &&
+	    kp->p_rlim_rss_cur / 1024 < pgtok(kp->p_vm_rssize))
+		*cp++ = '>';
+	if (kp->p_eflag & EPROC_SLEADER)
+		*cp++ = 's';
+	if ((flag & P_CONTROLT) && kp->p__pgid == kp->p_tpgid)
+		*cp++ = '+';
+	*cp = '\0';
+
+	if (state == 'R' && ncpu && kp->p_cpuid != KI_NOCPU) {
+		char pbuf[16];
+
+		snprintf(pbuf, sizeof pbuf, "/%llu", kp->p_cpuid);
+		*++cp = '\0';
+		strlcat(buf, pbuf, sizeof buf);
+		cp = buf + strlen(buf);
+	}
+
+	(void)printf("%-*s", v->width, buf);
+}
+
+void
+pri(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*d", v->width, kp->p_priority - PZERO);
+}
+
+void
+pnice(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+	v = ve->var;
+	(void)printf("%*d", v->width, kp->p_nice - NZERO);
+}
+
+void
+euname(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%-*s",
+	    (int)v->width, user_from_uid(kp->p_uid, 0));
+}
+
+void
+runame(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%-*s",
+	    (int)v->width, user_from_uid(kp->p_ruid, 0));
+}
+
+void
+gname(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%-*s",
+	    (int)v->width, group_from_gid(kp->p_gid, 0));
+}
+
+void
+rgname(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%-*s",
+	    (int)v->width, group_from_gid(kp->p_rgid, 0));
+}
+
+void
+tdev(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+	dev_t dev;
+	char buff[16];
+
+	v = ve->var;
+	dev = kp->p_tdev;
+	if (dev == NODEV)
+		(void)printf("%*s", v->width, "??");
+	else {
+		(void)snprintf(buff, sizeof(buff),
+		    "%d/%d", major(dev), minor(dev));
+		(void)printf("%*s", v->width, buff);
+	}
+}
+
+void
+tname(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+	dev_t dev;
+	char *ttname;
+
+	v = ve->var;
+	dev = kp->p_tdev;
+	if (dev == NODEV || (ttname = devname(dev, S_IFCHR)) == NULL)
+		(void)printf("%-*s", v->width, "??");
+	else {
+		if (strncmp(ttname, "tty", 3) == 0)
+			ttname += 3;
+		(void)printf("%*.*s%c", v->width-1, v->width-1, ttname,
+			kp->p_eflag & EPROC_CTTY ? ' ' : '-');
+	}
+}
+
+void
+longtname(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+	dev_t dev;
+	char *ttname;
+
+	v = ve->var;
+	dev = kp->p_tdev;
+	if (dev == NODEV || (ttname = devname(dev, S_IFCHR)) == NULL)
+		(void)printf("%-*s", v->width, "??");
+	else
+		(void)printf("%-*s", v->width, ttname);
+}
+
+void
+started(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+	static time_t now;
+	time_t startt;
+	struct tm *tp;
+	char buf[100];
+
+	v = ve->var;
+	if (!kp->p_uvalid) {
+		(void)printf("%-*s", v->width, "-");
+		return;
+	}
+
+	startt = kp->p_ustart_sec;
+	tp = localtime(&startt);
+	if (!now)
+		(void)time(&now);
+	if (now - kp->p_ustart_sec < 24 * SECSPERHOUR) {
+		(void)strftime(buf, sizeof(buf) - 1, "%l:%M%p", tp);
+	} else if (now - kp->p_ustart_sec < 7 * SECSPERDAY) {
+		(void)strftime(buf, sizeof(buf) - 1, "%a%I%p", tp);
+	} else
+		(void)strftime(buf, sizeof(buf) - 1, "%e%b%y", tp);
+	(void)printf("%-*s", v->width, buf);
+}
+
+void
+lstarted(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+	time_t startt;
+	char buf[100];
+
+	v = ve->var;
+	if (!kp->p_uvalid) {
+		(void)printf("%-*s", v->width, "-");
+		return;
+	}
+	startt = kp->p_ustart_sec;
+	(void)strftime(buf, sizeof(buf) -1, "%c",
+	    localtime(&startt));
+	(void)printf("%-*s", v->width, buf);
+}
+
+void
+wchan(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	if (kp->p_wchan) {
+		int n;
+
+		if (kp->p_wmesg) {
+			n = min(v->width, WMESGLEN);
+			(void)printf("%-*.*s", n, n, kp->p_wmesg);
+			if (v->width > n)
+				(void)printf("%*s", v->width - n, "");
+		} else
+			(void)printf("%-*lx", v->width,
+			    (long)kp->p_wchan &~ KERNBASE);
+	} else
+		(void)printf("%-*s", v->width, "-");
+}
+
+void
+vsize(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*d", v->width,
+	    pgtok(kp->p_vm_dsize + kp->p_vm_ssize + kp->p_vm_tsize));
+}
+
+void
+rssize(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	/* XXX don't have info about shared */
+	(void)printf("%*d", v->width, (kp->p_flag & P_SYSTEM) ? 0 :
+	    pgtok(kp->p_vm_rssize));
+}
+
+void
+p_rssize(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*d", v->width, (kp->p_flag & P_SYSTEM) ? 0 :
+	    pgtok(kp->p_vm_rssize));
+}
+
+void
+cputime(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+	long secs;
+	long psecs;	/* "parts" of a second. first micro, then centi */
+	char obuff[128];
+
+	v = ve->var;
+	if (kp->p_stat == SZOMB || !kp->p_uvalid) {
+		secs = 0;
+		psecs = 0;
+	} else {
+		/*
+		 * This counts time spent handling interrupts.  We could
+		 * fix this, but it is not 100% trivial (and interrupt
+		 * time fractions only work on the sparc anyway).	XXX
+		 */
+		secs = kp->p_rtime_sec;
+		psecs = kp->p_rtime_usec;
+		if (sumrusage) {
+			secs += kp->p_uctime_sec;
+			psecs += kp->p_uctime_usec;
+		}
+		/*
+		 * round and scale to 100's
+		 */
+		psecs = (psecs + 5000) / 10000;
+		secs += psecs / 100;
+		psecs = psecs % 100;
+	}
+	(void)snprintf(obuff, sizeof(obuff),
+	    "%3ld:%02ld.%02ld", secs/60, secs%60, psecs);
+	(void)printf("%*s", v->width, obuff);
+}
+
+double
+getpcpu(const struct kinfo_proc2 *kp)
+{
+	double d;
+
+	if (fscale == 0)
+		return (0.0);
+
+#define	fxtofl(fixpt)	((double)(fixpt) / fscale)
+
+	/* XXX - I don't like this */
+	if (kp->p_swtime == 0)
+		return (0.0);
+	if (rawcpu)
+		return (100.0 * fxtofl(kp->p_pctcpu));
+
+	d = kp->p_swtime * log(fxtofl(ccpu));
+	if (d < -700.0)
+		d = 0.0;		/* avoid IEEE underflow */
+	else
+		d = exp(d);
+	if (d == 1.0)
+		return (0.0);
+	return (100.0 * fxtofl(kp->p_pctcpu) /
+		(1.0 - d));
+}
+
+void
+pcpu(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*.1f", v->width, getpcpu(kp));
+}
+
+double
+getpmem(const struct kinfo_proc2 *kp)
+{
+	double fracmem;
+	int szptudot;
+
+	if (mempages == 0)
+		return (0.0);
+
+	if (kp->p_flag & P_SYSTEM)
+		return (0.0);
+	/* XXX want pmap ptpages, segtab, etc. (per architecture) */
+	szptudot = USPACE/getpagesize();
+	/* XXX don't have info about shared */
+	fracmem = ((float)kp->p_vm_rssize + szptudot)/mempages;
+	return (100.0 * fracmem);
+}
+
+void
+pmem(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*.1f", v->width, getpmem(kp));
+}
+
+void
+pagein(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*llu", v->width,
+	    kp->p_uvalid ? kp->p_uru_majflt : 0);
+}
+
+void
+maxrss(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*lld", v->width, kp->p_rlim_rss_cur / 1024);
+}
+
+void
+tsize(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*d", v->width, pgtok(kp->p_vm_tsize));
+}
+
+void
+dsize(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*d", v->width, pgtok(kp->p_vm_dsize));
+}
+
+void
+ssize(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	(void)printf("%*d", v->width, pgtok(kp->p_vm_ssize));
+}
+
+/*
+ * Generic output routines.  Print fields from various prototype
+ * structures.
+ */
+static void
+printval(char *bp, VAR *v)
+{
+	char ofmt[32];
+
+	snprintf(ofmt, sizeof(ofmt), "%%%s*%s", (v->flag & LJUST) ? "-" : "",
+	    v->fmt);
+
+	/*
+	 * Note that the "INF127" check is nonsensical for types
+	 * that are or can be signed.
+	 */
+#define	GET(type)		(*(type *)bp)
+#define	CHK_INF127(n)		(((n) > 127) && (v->flag & INF127) ? 127 : (n))
+
+	switch (v->type) {
+	case INT8:
+		(void)printf(ofmt, v->width, GET(int8_t));
+		break;
+	case UINT8:
+		(void)printf(ofmt, v->width, CHK_INF127(GET(u_int8_t)));
+		break;
+	case INT16:
+		(void)printf(ofmt, v->width, GET(int16_t));
+		break;
+	case UINT16:
+		(void)printf(ofmt, v->width, CHK_INF127(GET(u_int16_t)));
+		break;
+	case INT32:
+		(void)printf(ofmt, v->width, GET(int32_t));
+		break;
+	case UINT32:
+		(void)printf(ofmt, v->width, CHK_INF127(GET(u_int32_t)));
+		break;
+	case INT64:
+		(void)printf(ofmt, v->width, GET(int64_t));
+		break;
+	case UINT64:
+		(void)printf(ofmt, v->width, CHK_INF127(GET(u_int64_t)));
+		break;
+	default:
+		errx(1, "unknown type %d", v->type);
+	}
+#undef GET
+#undef CHK_INF127
+}
+
+void
+pvar(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+	if ((v->flag & USER) && !kp->p_uvalid)
+		(void)printf("%*s", v->width, "-");
+	else
+		printval((char *)kp + v->off, v);
+}
+
+void
+emulname(const struct kinfo_proc2 *kp, VARENT *ve)
+{
+	VAR *v;
+
+	v = ve->var;
+
+	(void)printf("%-*s", (int)v->width, kp->p_emul);
+}
Index: sbin/instps/ps.c
===================================================================
RCS file: sbin/instps/ps.c
diff -N sbin/instps/ps.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sbin/instps/ps.c	13 Feb 2009 09:20:25 -0000	1.1.2.3
@@ -0,0 +1,465 @@
+/*	$OpenBSD: ps.c,v 1.45 2008/03/08 19:20:12 millert Exp $	*/
+/*	$NetBSD: ps.c,v 1.15 1995/05/18 20:33:25 mycroft Exp $	*/
+
+/*-
+ * Copyright (c) 1990, 1993, 1994
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef lint
+static char copyright[] =
+"@(#) Copyright (c) 1990, 1993, 1994\n\
+	The Regents of the University of California.  All rights reserved.\n";
+#endif /* not lint */
+
+#ifndef lint
+#if 0
+static char sccsid[] = "@(#)ps.c	8.4 (Berkeley) 4/2/94";
+#else
+static char rcsid[] = "$OpenBSD: ps.c,v 1.45 2008/03/08 19:20:12 millert Exp $";
+#endif
+#endif /* not lint */
+
+#include <sys/param.h>
+#include <sys/user.h>
+#include <sys/time.h>
+#include <sys/resource.h>
+#include <sys/proc.h>
+#include <sys/stat.h>
+#include <sys/ioctl.h>
+#include <sys/sysctl.h>
+#include <sys/types.h>
+
+#include <ctype.h>
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <paths.h>
+#include <pwd.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <limits.h>
+
+#include "ps.h"
+
+extern char *__progname;
+
+struct varent *vhead;
+
+int	eval;			/* exit value */
+int	rawcpu;			/* -C */
+int	sumrusage;		/* -S */
+int	termwidth;		/* width of screen (0 == infinity) */
+int	totwidth;		/* calculated width of requested variables */
+
+int	ncpu = 1;
+
+int	needcomm, neednlist;
+
+enum sort { DEFAULT, SORTMEM, SORTCPU } sortby = DEFAULT;
+
+static char	*kludge_oldps_options(char *);
+static int	 pscomp(const void *, const void *);
+static void	 scanvars(void);
+static void	 usage(void);
+
+char dfmt[] = "pid tt state time command";
+char jfmt[] = "user pid ppid pgid sess jobc state tt time command";
+char lfmt[] = "uid pid ppid cpu pri nice vsz rss wchan state tt time command";
+char   o1[] = "pid";
+char   o2[] = "tt state time command";
+char ufmt[] = "user pid %cpu %mem vsz rss tt state start time command";
+char vfmt[] = "pid state time sl re pagein vsz rss lim tsiz %cpu %mem command";
+
+int
+main(int argc, char *argv[])
+{
+	struct kinfo_proc2 *kp, **kinfo;
+	instid_t inst;
+	struct varent *vent;
+	struct winsize ws;
+	struct passwd *pwd;
+	dev_t ttydev;
+	pid_t pid;
+	uid_t uid;
+	int all, ch, flag, i, fmt, lineno, nentries, mib[6];
+	int prtheader, wflag, kflag, what, Uflag, xflg;
+	char errbuf[_POSIX2_LINE_MAX];
+	size_t size;
+
+	if ((ioctl(STDOUT_FILENO, TIOCGWINSZ, &ws) == -1 &&
+	    ioctl(STDERR_FILENO, TIOCGWINSZ, &ws) == -1 &&
+	    ioctl(STDIN_FILENO,  TIOCGWINSZ, &ws) == -1) ||
+	    ws.ws_col == 0)
+		termwidth = 79;
+	else
+		termwidth = ws.ws_col - 1;
+
+	if (argc > 1)
+		argv[1] = kludge_oldps_options(argv[1]);
+
+	all = fmt = prtheader = wflag = kflag = Uflag = xflg = 0;
+	pid = -1;
+	uid = 0;
+	inst = getinstid();
+	ttydev = NODEV;
+
+	while ((ch = getopt(argc, argv,
+	    "aCghi:jkLlmO:o:p:rSTt:U:uvW:wx")) != -1)
+		switch (ch) {
+		case 'a':
+			all = 1;
+			break;
+		case 'C':
+			rawcpu = 1;
+			break;
+		case 'g':
+			break;			/* no-op */
+		case 'h':
+			prtheader = ws.ws_row > 5 ? ws.ws_row : 22;
+			break;
+		case 'i':
+			inst = (instid_t)atoll(optarg);
+			break;
+		case 'j':
+			parsefmt(jfmt);
+			fmt = 1;
+			jfmt[0] = '\0';
+			break;
+		case 'k':
+			kflag++;
+			break;
+		case 'L':
+			showkey();
+			exit(0);
+		case 'l':
+			parsefmt(lfmt);
+			fmt = 1;
+			lfmt[0] = '\0';
+			break;
+		case 'm':
+			sortby = SORTMEM;
+			break;
+		case 'O':
+			parsefmt(o1);
+			parsefmt(optarg);
+			parsefmt(o2);
+			o1[0] = o2[0] = '\0';
+			fmt = 1;
+			break;
+		case 'o':
+			parsefmt(optarg);
+			fmt = 1;
+			break;
+		case 'p':
+			pid = atol(optarg);
+			xflg = 1;
+			break;
+		case 'r':
+			sortby = SORTCPU;
+			break;
+		case 'S':
+			sumrusage = 1;
+			break;
+		case 'T':
+			if ((optarg = ttyname(STDIN_FILENO)) == NULL)
+				errx(1, "stdin: not a terminal");
+			/* FALLTHROUGH */
+		case 't': {
+			struct stat sb;
+			char *ttypath, pathbuf[MAXPATHLEN];
+
+			if (strcmp(optarg, "co") == 0)
+				ttypath = _PATH_CONSOLE;
+			else if (*optarg != '/')
+				(void)snprintf(ttypath = pathbuf,
+				    sizeof(pathbuf), "%s%s", _PATH_TTY, optarg);
+			else
+				ttypath = optarg;
+			if (stat(ttypath, &sb) == -1)
+				err(1, "%s", ttypath);
+			if (!S_ISCHR(sb.st_mode))
+				errx(1, "%s: not a terminal", ttypath);
+			ttydev = sb.st_rdev;
+			break;
+		}
+		case 'U':
+			pwd = getpwnam(optarg);
+			if (pwd == NULL)
+				errx(1, "%s: no such user", optarg);
+			uid = pwd->pw_uid;
+			endpwent();
+			Uflag = xflg = 1;
+			break;
+		case 'u':
+			parsefmt(ufmt);
+			sortby = SORTCPU;
+			fmt = 1;
+			ufmt[0] = '\0';
+			break;
+		case 'v':
+			parsefmt(vfmt);
+			sortby = SORTMEM;
+			fmt = 1;
+			vfmt[0] = '\0';
+			break;
+		case 'w':
+			if (wflag)
+				termwidth = UNLIMITED;
+			else if (termwidth < 131)
+				termwidth = 131;
+			wflag++;
+			break;
+		case 'x':
+			xflg = 1;
+			break;
+		default:
+			usage();
+		}
+	argc -= optind;
+	argv += optind;
+
+	if (!fmt)
+		parsefmt(dfmt);
+
+	/* XXX - should be cleaner */
+	if (!all && ttydev == NODEV && pid == -1 && !Uflag) {
+		uid = getuid();
+		Uflag = 1;
+	}
+
+	/*
+	 * scan requested variables, noting what structures are needed,
+	 * and adjusting header widths as appropriate.
+	 */
+	scanvars();
+
+	if (neednlist && !nlistread)
+		(void) donlist();
+
+	/*
+	 * get proc list
+	 */
+	if (Uflag) {
+		what = KERN_PROC_UID;
+		flag = uid;
+	} else if (ttydev != NODEV) {
+		what = KERN_PROC_TTY;
+		flag = ttydev;
+	} else if (pid != -1) {
+		what = KERN_PROC_PID;
+		flag = pid;
+	} else if (kflag) {
+		what = KERN_PROC_KTHREAD;
+		flag = 0;
+	} else {
+		what = KERN_PROC_ALL;
+		flag = 0;
+	}
+
+	mib[0] = CTL_HW;
+	mib[1] = HW_NCPU;
+	size = sizeof(ncpu);
+	(void) sysctl(mib, 2, &ncpu, &size, NULL, 0);
+
+	/*
+	 * select procs
+	 */
+	mib[0] = CTL_KERN;
+	mib[1] = KERN_INSTPROC2;
+	mib[2] = inst;
+	mib[3] = what;
+	mib[4] = flag;
+	mib[5] = sizeof(struct kinfo_proc2);
+	mib[6] = 0;
+
+retry:
+	if (sysctl(mib, 7, NULL, &size, NULL, 0) < 0)
+		err(1, "sysctl");
+
+	size = 5 * size / 4;		/* extra slop */
+	if ((kp = malloc(size)) == NULL)
+		err(1, "failed to allocate memory for proc structures");
+	mib[6] = (int)(size / sizeof(struct kinfo_proc2));
+	if (sysctl(mib, 7, kp, &size, NULL, 0) < 0) {
+		if (errno == ENOMEM) {
+			free(kp);
+			goto retry;
+		}
+		err(1, "sysctl");
+	}
+	nentries = (int)(size / sizeof(struct kinfo_proc2));
+
+	/*
+	 * print header
+	 */
+	printheader();
+	if (nentries == 0)
+		exit(1);
+	/*
+	 * sort proc list, we convert from an array of structs to an array
+	 * of pointers to make the sort cheaper.
+	 */
+	if ((kinfo = calloc(sizeof(*kinfo), nentries)) == NULL)
+		err(1, "failed to allocate memory for proc pointers");
+	for (i = 0; i < nentries; i++)
+		kinfo[i] = &kp[i];
+	qsort(kinfo, nentries, sizeof(*kinfo), pscomp);
+	/*
+	 * for each proc, call each variable output function.
+	 */
+	for (i = lineno = 0; i < nentries; i++) {
+		if (xflg == 0 && ((int)kinfo[i]->p_tdev == NODEV ||
+		    (kinfo[i]->p_flag & P_CONTROLT ) == 0))
+			continue;
+		for (vent = vhead; vent; vent = vent->next) {
+			(vent->var->oproc)(kinfo[i], vent);
+			if (vent->next != NULL)
+				(void)putchar(' ');
+		}
+		(void)putchar('\n');
+		if (prtheader && lineno++ == prtheader - 4) {
+			(void)putchar('\n');
+			printheader();
+			lineno = 0;
+		}
+	}
+	exit(eval);
+}
+
+static void
+scanvars(void)
+{
+	struct varent *vent;
+	VAR *v;
+	int i;
+
+	for (vent = vhead; vent; vent = vent->next) {
+		v = vent->var;
+		i = strlen(v->header);
+		if (v->width < i)
+			v->width = i;
+		totwidth += v->width + 1;	/* +1 for space */
+		if (v->flag & COMM)
+			needcomm = 1;
+		if (v->flag & NLIST)
+			neednlist = 1;
+	}
+	totwidth--;
+}
+
+static int
+pscomp(const void *v1, const void *v2)
+{
+	const struct kinfo_proc2 *kp1 = *(const struct kinfo_proc2 **)v1;
+	const struct kinfo_proc2 *kp2 = *(const struct kinfo_proc2 **)v2;
+	int i;
+#define VSIZE(k) ((k)->p_vm_dsize + (k)->p_vm_ssize + (k)->p_vm_tsize)
+
+	if (sortby == SORTCPU && (i = getpcpu(kp2) - getpcpu(kp1)) != 0)
+		return (i);
+	if (sortby == SORTMEM && (i = VSIZE(kp2) - VSIZE(kp1)) != 0)
+		return (i);
+	if ((i = kp1->p_tdev - kp2->p_tdev) == 0 &&
+	    (i = kp1->p_ustart_sec - kp2->p_ustart_sec) == 0)
+		i = kp1->p_ustart_usec - kp2->p_ustart_usec;
+	return (i);
+}
+
+/*
+ * ICK (all for getopt), would rather hide the ugliness
+ * here than taint the main code.
+ *
+ *  ps foo -> ps -foo
+ *  ps 34 -> ps -p34
+ *
+ * The old convention that 't' with no trailing tty arg means the users
+ * tty, is only supported if argv[1] doesn't begin with a '-'.  This same
+ * feature is available with the option 'T', which takes no argument.
+ */
+static char *
+kludge_oldps_options(char *s)
+{
+	size_t len;
+	char *newopts, *ns, *cp;
+
+	len = strlen(s);
+	if ((newopts = ns = malloc(2 + len + 1)) == NULL)
+		err(1, NULL);
+	/*
+	 * options begin with '-'
+	 */
+	if (*s != '-')
+		*ns++ = '-';	/* add option flag */
+
+	/*
+	 * gaze to end of argv[1]
+	 */
+	cp = s + len - 1;
+	/*
+	 * if last letter is a 't' flag with no argument (in the context
+	 * of the oldps options -- option string NOT starting with a '-' --
+	 * then convert to 'T' (meaning *this* terminal, i.e. ttyname(0)).
+	 */
+	if (*cp == 't' && *s != '-')
+		*cp = 'T';
+	else {
+		/*
+		 * otherwise check for trailing number, which *may* be a
+		 * pid.
+		 */
+		while (cp >= s && isdigit(*cp))
+			--cp;
+	}
+	cp++;
+	memmove(ns, s, (size_t)(cp - s));	/* copy up to trailing number */
+	ns += cp - s;
+	/*
+	 * if there's a trailing number, and not a preceding 'p' (pid) or
+	 * 't' (tty) flag, then assume it's a pid and insert a 'p' flag.
+	 */
+	if (isdigit(*cp) && (cp == s || (cp[-1] != 't' && cp[-1] != 'p' &&
+	    (cp - 1 == s || cp[-2] != 't'))))
+		*ns++ = 'p';
+	/* and append the number */
+	(void)strlcpy(ns, cp, newopts + len + 3 - ns);
+
+	return (newopts);
+}
+
+static void
+usage(void)
+{
+	(void)fprintf(stderr,
+	    "usage: %s [-aChjkLlmrSTuvwx] [-i inst] [-O fmt] [-o fmt] [-p pid]\n",
+	    __progname);	
+	(void)fprintf(stderr,
+	    "%-*s[-t tty] [-U username]\n", (int)strlen(__progname) + 8, "");
+	exit(1);
+}
